Package org.codehaus.groovy.transform

# Interface ASTTransformation

All Known Implementing Classes:
  `AbstractASTTransformation`, `AbstractInterruptibleASTTransformation`, `ActiveObjectASTTransformation`, `AstBuilderTransformation`, `AutoCloneASTStubber`, `AutoCloneASTTransformation`, `AutoFinalASTTransformation`, `AutoImplementASTStubber`, `AutoImplementASTTransformation`, `BaseASTTransformation`, `BaseScriptASTTransformation`, `BindableASTStubber`, `BindableASTTransformation`, `BuilderASTStubber`, `BuilderASTTransformation`, `CategoryASTTransformation`, `ClosureExpressionEvaluationASTTransformation`, `DelegateASTStubber`, `DelegateASTTransformation`, `EqualsAndHashCodeASTStubber`, `EqualsAndHashCodeASTTransformation`, `ExternalizeMethodsASTStubber`, `ExternalizeMethodsASTTransformation`, `ExternalizeVerifierASTTransformation`, `FieldASTTransformation`, `FinalASTStubber`, `FinalASTTransformation`, `GContractsASTTransformation`, `GinqASTTransformation`, `GrabAnnotationTransformation`, `ImmutableASTTransformation`, `IndexedPropertyASTStubber`, `IndexedPropertyASTTransformation`, `InheritConstructorsASTStubber`, `InheritConstructorsASTTransformation`, `LazyASTStubber`, `LazyASTTransformation`, `LogASTTransformation`, `LoopInvariantASTTransformation`, `LoopVariantASTTransformation`, `MacroClassTransformation`, `MacroTransformation`, `MapConstructorASTStubber`, `MapConstructorASTTransformation`, `MemoizedASTTransformation`, `MethodCallTransformation`, `MethodVariantASTTransformation`, `MethodVariantInheritanceASTTransformation`, `MixinASTTransformation`, `ModifiesASTTransformation`, `ModifiesEnsuresValidationTransformation`, `NamedVariantASTStubber`, `NamedVariantASTTransformation`, `NewifyASTTransformation`, `NonSealedASTTransformation`, `NotYetImplementedASTTransformation`, `NullCheckASTTransformation`, `OperatorRenameASTTransformation`, `PackageScopeASTTransformation`, `ParallelASTTransformation`, `ReadWriteLockASTTransformation`, `RecordBaseASTStubber`, `RecordCompletionASTTransformation`, `RecordTypeASTTransformation`, `SafeRegexASTTransformation`, `SealedASTTransformation`, `SealedCompletionASTTransformation`, `SingletonASTStubber`, `SingletonASTTransformation`, `SortableASTStubber`, `SortableASTTransformation`, `SourceURIASTTransformation`, `StaticCompileTransformation`, `StaticTypesTransformation`, `SynchronizedASTTransformation`, `TailRecursiveASTTransformation`, `ThrowsIfASTTransformation`, `ToStringASTStubber`, `ToStringASTTransformation`, `TraitASTTransformation`, `TupleConstructorASTStubber`, `TupleConstructorASTTransformation`, `VetoableASTStubber`, `VetoableASTTransformation`

public interface ASTTransformation
This class is instantiated and invoked when an AST transformation is activated. For Global AST Transformations, this interface is called once per SourceUnit, which is usually a Groovy source file. For Local AST Transformations, this interface is invoked once every time the Local annotation marker is encountered.

You must annotate this class with `GroovyASTTransformation` so that Groovy knows which `CompilePhase` to run in.

See Also:
  - `GroovyASTTransformation`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.

- ## Method Details

  - ### visit

    void visit(ASTNode[] nodes, SourceUnit source)
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.